# coding: utf-8


"""
IGNORE:
    Nutanix Monitoring APIs

    Manage Alerts, Alert policies, Events and Audits  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
import ntnx_monitoring_py_client.models
from ntnx_monitoring_py_client.models.OneOfmonitoring.v4.serviceability.ArchiveOptsupload_params import ArchiveOptsupload_params  # noqa: F401,E501

class ArchiveOpts(object):

    """Arguments specifying details of the archive to be collected.

    :param archive_name: (:attr:`archive_name`) Custom name of the archive folder. (**Default** 'NTNX-Log')
    :type archive_name: 
     max=100 chars
    
    :param upload_params: (:attr:`upload_params`) This parameter specifies the target/destination location of collected archive. User must specify one of the below target/destination. - LocalUploadParams: Use this option to store archive on local disk.   Full archive path can be found in the completion_details field of the task. - NtnxServerUploadParams: Use this option to upload archive to Nutanix server. - CustomServerUploadParams: Use this option to upload archive to custom FTP/SFTP server. - StorageContainerUploadParams: Use this option to upload archive to a storage container.    Localhost storage container uploads are not supported on PC. 
    :type upload_params: required
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'archive_name': 'str',
        'upload_params': 'OneOfmonitoring.v4.serviceability.ArchiveOptsupload_params',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'archive_name': 'archiveName',
        'upload_params': 'uploadParams',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, archive_name='NTNX-Log', upload_params=None, *args, **kwargs):  # noqa: E501
        self.__archive_name = None
        self.__upload_params = None
        self.discriminator = None
        if archive_name is not None:
            self.__archive_name = archive_name
        self.__upload_params = upload_params
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'monitoring.v4.serviceability.ArchiveOpts'

    def _initialize_object_version(self):
        return 'v4.r0'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def archive_name(self):
        """
        Custom name of the archive folder.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__archive_name

    @archive_name.setter
    def archive_name(self, archive_name):
        if archive_name is not None and len(archive_name) > 100:
            raise ValueError("Invalid value for `archive_name`, length must be less than or equal to `100`")  # noqa: E501

        self.__archive_name = archive_name

    @property
    def upload_params(self):
        """
        This parameter specifies the target/destination location of collected archive. User must specify one of the below target/destination. - LocalUploadParams: Use this option to store archive on local disk.   Full archive path can be found in the completion_details field of the task. - NtnxServerUploadParams: Use this option to upload archive to Nutanix server. - CustomServerUploadParams: Use this option to upload archive to custom FTP/SFTP server. - StorageContainerUploadParams: Use this option to upload archive to a storage container.    Localhost storage container uploads are not supported on PC. 

        :type:
                :class:`~ntnx_monitoring_py_client.models.monitoring.v4.serviceability.LocalUploadParams` | 
                :class:`~ntnx_monitoring_py_client.models.monitoring.v4.serviceability.NtnxServerUploadParams` | 
                :class:`~ntnx_monitoring_py_client.models.monitoring.v4.serviceability.CustomServerUploadParams` | 
                :class:`~ntnx_monitoring_py_client.models.monitoring.v4.serviceability.StorageContainerUploadParams`
        """  # noqa: E501
        return self.__upload_params

    @upload_params.setter
    def upload_params(self, upload_params):
        if upload_params is None:
            raise ValueError("Invalid value for `upload_params`, must not be `None`")  # noqa: E501

        self.__upload_params = upload_params

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if attr_type.startswith('OneOf'):
                type = getattr(ntnx_monitoring_py_client.models, attr_type.split('.')[-1])
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(ArchiveOpts, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ArchiveOpts):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

