# coding: utf-8


"""
IGNORE:
    Nutanix Monitoring APIs

    Manage Alerts, Alert policies, Events and Audits  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_monitoring_py_client.models.monitoring.v4.serviceability.ConnectionStatus import ConnectionStatus  # noqa: F401,E501
from ntnx_monitoring_py_client.models.monitoring.v4.serviceability.ParameterizedMessage import ParameterizedMessage  # noqa: F401,E501

class CommunicationStatus(object):

    """Status of the remote tunnel or service that is running on top of the remote tunnel. For example, pulse or alert email.

    :param last_checked_time: (:attr:`last_checked_time`) Last checked time.
    :type last_checked_time: 
    
    
    :param last_changed_time: (:attr:`last_changed_time`) Last changed time.
    :type last_changed_time: 
    
    
    :param last_successful_transmission_time: (:attr:`last_successful_transmission_time`) Last successful transmission time.
    :type last_successful_transmission_time: 
    
    
    :param status: (:attr:`status`) 
    :type status: 
    
    
    :param message: (:attr:`message`) 
    :type message: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'last_checked_time': 'datetime',
        'last_changed_time': 'datetime',
        'last_successful_transmission_time': 'datetime',
        'status': 'monitoring.v4.serviceability.ConnectionStatus',
        'message': 'monitoring.v4.serviceability.ParameterizedMessage',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'last_checked_time': 'lastCheckedTime',
        'last_changed_time': 'lastChangedTime',
        'last_successful_transmission_time': 'lastSuccessfulTransmissionTime',
        'status': 'status',
        'message': 'message',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, last_checked_time=None, last_changed_time=None, last_successful_transmission_time=None, status=None, message=None, *args, **kwargs):  # noqa: E501
        self.__last_checked_time = None
        self.__last_changed_time = None
        self.__last_successful_transmission_time = None
        self.__status = None
        self.__message = None
        self.discriminator = None
        if last_checked_time is not None:
            self.__last_checked_time = last_checked_time
        if last_changed_time is not None:
            self.__last_changed_time = last_changed_time
        if last_successful_transmission_time is not None:
            self.__last_successful_transmission_time = last_successful_transmission_time
        if status is not None:
            self.__status = status
        if message is not None:
            self.__message = message
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'monitoring.v4.serviceability.CommunicationStatus'

    def _initialize_object_version(self):
        return 'v4.r0'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def last_checked_time(self):
        """
        Last checked time.

        :type:
                :class:`~datetime`
        """  # noqa: E501
        return self.__last_checked_time

    @last_checked_time.setter
    def last_checked_time(self, last_checked_time):

        self.__last_checked_time = last_checked_time

    @property
    def last_changed_time(self):
        """
        Last changed time.

        :type:
                :class:`~datetime`
        """  # noqa: E501
        return self.__last_changed_time

    @last_changed_time.setter
    def last_changed_time(self, last_changed_time):

        self.__last_changed_time = last_changed_time

    @property
    def last_successful_transmission_time(self):
        """
        Last successful transmission time.

        :type:
                :class:`~datetime`
        """  # noqa: E501
        return self.__last_successful_transmission_time

    @last_successful_transmission_time.setter
    def last_successful_transmission_time(self, last_successful_transmission_time):

        self.__last_successful_transmission_time = last_successful_transmission_time

    @property
    def status(self):
        """
        

        :type:
            :class:`~ntnx_monitoring_py_client.models.monitoring.v4.serviceability.ConnectionStatus`
        """  # noqa: E501
        return self.__status

    @status.setter
    def status(self, status):

        self.__status = status

    @property
    def message(self):
        """
        

        :type:
            :class:`~ntnx_monitoring_py_client.models.monitoring.v4.serviceability.ParameterizedMessage`
        """  # noqa: E501
        return self.__message

    @message.setter
    def message(self, message):

        self.__message = message

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(CommunicationStatus, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CommunicationStatus):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

