# coding: utf-8


"""
IGNORE:
    Nutanix Monitoring APIs

    Manage Alerts, Alert policies, Events and Audits  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_monitoring_py_client.models.common.v1.config.IPAddressOrFQDN import IPAddressOrFQDN  # noqa: F401,E501
from ntnx_monitoring_py_client.models.monitoring.v4.serviceability.Credential import Credential  # noqa: F401,E501
from ntnx_monitoring_py_client.models.monitoring.v4.serviceability.ServerUploadProtocol import ServerUploadProtocol  # noqa: F401,E501

class CustomServerUploadParams(object):

    """The parameters for uploading the archive if the destination is a custom server.

    :param protocol: (:attr:`protocol`) 
    :type protocol: required
    
    
    :param server_address: (:attr:`server_address`) 
    :type server_address: required
    
    
    :param port: (:attr:`port`) Port of the target. Mandatory for SFTP and FTP protocol.
    :type port: 
    
    
    :param credential: (:attr:`credential`) 
    :type credential: required
    
    
    :param path: (:attr:`path`) Path where the archive will be stored on the custom server. The path should pre-exist. If not specified, the bundle will get stored in the location as set in $HOME.
    :type path: 
     max=100 chars
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'protocol': 'monitoring.v4.serviceability.ServerUploadProtocol',
        'server_address': 'common.v1.config.IPAddressOrFQDN',
        'port': 'int',
        'credential': 'monitoring.v4.serviceability.Credential',
        'path': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'protocol': 'protocol',
        'server_address': 'serverAddress',
        'port': 'port',
        'credential': 'credential',
        'path': 'path',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, protocol=None, server_address=None, port=None, credential=None, path=None, *args, **kwargs):  # noqa: E501
        self.__protocol = None
        self.__server_address = None
        self.__port = None
        self.__credential = None
        self.__path = None
        self.discriminator = None
        self.__protocol = protocol
        self.__server_address = server_address
        if port is not None:
            self.__port = port
        self.__credential = credential
        if path is not None:
            self.__path = path
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'monitoring.v4.serviceability.CustomServerUploadParams'

    def _initialize_object_version(self):
        return 'v4.r0'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def protocol(self):
        """
        

        :type:
            :class:`~ntnx_monitoring_py_client.models.monitoring.v4.serviceability.ServerUploadProtocol`
        """  # noqa: E501
        return self.__protocol

    @protocol.setter
    def protocol(self, protocol):
        if protocol is None:
            raise ValueError("Invalid value for `protocol`, must not be `None`")  # noqa: E501

        self.__protocol = protocol

    @property
    def server_address(self):
        """
        

        :type:
            :class:`~ntnx_monitoring_py_client.models.common.v1.config.IPAddressOrFQDN`
        """  # noqa: E501
        return self.__server_address

    @server_address.setter
    def server_address(self, server_address):
        if server_address is None:
            raise ValueError("Invalid value for `server_address`, must not be `None`")  # noqa: E501

        self.__server_address = server_address

    @property
    def port(self):
        """
        Port of the target. Mandatory for SFTP and FTP protocol.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__port

    @port.setter
    def port(self, port):

        self.__port = port

    @property
    def credential(self):
        """
        

        :type:
            :class:`~ntnx_monitoring_py_client.models.monitoring.v4.serviceability.Credential`
        """  # noqa: E501
        return self.__credential

    @credential.setter
    def credential(self, credential):
        if credential is None:
            raise ValueError("Invalid value for `credential`, must not be `None`")  # noqa: E501

        self.__credential = credential

    @property
    def path(self):
        """
        Path where the archive will be stored on the custom server. The path should pre-exist. If not specified, the bundle will get stored in the location as set in $HOME.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__path

    @path.setter
    def path(self, path):
        if path is not None and len(path) > 100:
            raise ValueError("Invalid value for `path`, length must be less than or equal to `100`")  # noqa: E501

        self.__path = path

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(CustomServerUploadParams, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CustomServerUploadParams):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

