# coding: utf-8


"""
IGNORE:
    Nutanix Monitoring APIs

    Manage Alerts, Alert policies, Events and Audits  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_monitoring_py_client.models.common.v1.response.ApiLink import ApiLink  # noqa: F401,E501
from ntnx_monitoring_py_client.models.common.v1.response.ExternalizableAbstractModel import ExternalizableAbstractModel  # noqa: F401,E501
from ntnx_monitoring_py_client.models.monitoring.v4.common.EntityReference import EntityReference  # noqa: F401,E501
from ntnx_monitoring_py_client.models.monitoring.v4.common.MetricDetail import MetricDetail  # noqa: F401,E501
from ntnx_monitoring_py_client.models.monitoring.v4.common.Parameter import Parameter  # noqa: F401,E501
from ntnx_monitoring_py_client.models.monitoring.v4.serviceability.EventEntityReference import EventEntityReference  # noqa: F401,E501

class Event(ExternalizableAbstractModel):

    """

    :param source_entity: (:attr:`source_entity`) 
    :type source_entity: 
    
    
    :param affected_entities: (:attr:`affected_entities`) List of all the entities that are affected by the event or audit.
    :type affected_entities: 
    
    
    :param metric_details: (:attr:`metric_details`) Details of the metric for a metric-based event.
    :type metric_details: 
    
    
    :param event_type: (:attr:`event_type`) A preconfigured or dynamically generated unique value for each event type.
    :type event_type: 
    
    
    :param classifications: (:attr:`classifications`) Various categories into which this event type can be classified. For example, hardware, storage, or license.
    :type classifications: 
    
    
    :param source_cluster_uuid: (:attr:`source_cluster_uuid`) Cluster UUID associated with the source entity of the event.
    :type source_cluster_uuid: 
    
    
    :param creation_time: (:attr:`creation_time`) The time in ISO 8601 format when the event was created.
    :type creation_time: 
    
    
    :param message: (:attr:`message`) Additional message associated with the event.
    :type message: 
     max=1024 chars
    
    :param cluster_uuid: (:attr:`cluster_uuid`) Cluster UUID associated with the cluster where the event was first raised.
    :type cluster_uuid: 
    
    
    :param parameters: (:attr:`parameters`) Additional parameters associated with the event. These parameters can be used to indicate custom key-value pairs for a given event instance. For example, a service down event in Prism Central can have the service name as a parameter.
    :type parameters: 
    
    
    :param service_name: (:attr:`service_name`) The service which raised the event or audit. For internal Nutanix services, this value is set to \"Nutanix\".
    :type service_name: 
     max=50 chars
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'source_entity': 'monitoring.v4.serviceability.EventEntityReference',
        'affected_entities': 'list[monitoring.v4.common.EntityReference]',
        'metric_details': 'list[monitoring.v4.common.MetricDetail]',
        'event_type': 'str',
        'classifications': 'list[str]',
        'source_cluster_uuid': 'str',
        'creation_time': 'datetime',
        'message': 'str',
        'cluster_uuid': 'str',
        'parameters': 'list[monitoring.v4.common.Parameter]',
        'service_name': 'str',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'source_entity': 'sourceEntity',
        'affected_entities': 'affectedEntities',
        'metric_details': 'metricDetails',
        'event_type': 'eventType',
        'classifications': 'classifications',
        'source_cluster_uuid': 'sourceClusterUUID',
        'creation_time': 'creationTime',
        'message': 'message',
        'cluster_uuid': 'clusterUUID',
        'parameters': 'parameters',
        'service_name': 'serviceName',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, source_entity=None, affected_entities=None, metric_details=None, event_type=None, classifications=None, source_cluster_uuid=None, creation_time=None, message=None, cluster_uuid=None, parameters=None, service_name=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        ExternalizableAbstractModel.__init__(self, ext_id, links, tenant_id, *args, **kwargs)
        self.__source_entity = None
        self.__affected_entities = None
        self.__metric_details = None
        self.__event_type = None
        self.__classifications = None
        self.__source_cluster_uuid = None
        self.__creation_time = None
        self.__message = None
        self.__cluster_uuid = None
        self.__parameters = None
        self.__service_name = None
        self.discriminator = None
        if source_entity is not None:
            self.__source_entity = source_entity
        if affected_entities is not None:
            self.__affected_entities = affected_entities
        if metric_details is not None:
            self.__metric_details = metric_details
        if event_type is not None:
            self.__event_type = event_type
        if classifications is not None:
            self.__classifications = classifications
        if source_cluster_uuid is not None:
            self.__source_cluster_uuid = source_cluster_uuid
        if creation_time is not None:
            self.__creation_time = creation_time
        if message is not None:
            self.__message = message
        if cluster_uuid is not None:
            self.__cluster_uuid = cluster_uuid
        if parameters is not None:
            self.__parameters = parameters
        if service_name is not None:
            self.__service_name = service_name

    def _initialize_object_type(self):
        return 'monitoring.v4.serviceability.Event'

    def _initialize_object_version(self):
        return 'v4.r0'


    @property
    def source_entity(self):
        """
        

        :type:
            :class:`~ntnx_monitoring_py_client.models.monitoring.v4.serviceability.EventEntityReference`
        """  # noqa: E501
        return self.__source_entity

    @source_entity.setter
    def source_entity(self, source_entity):

        self.__source_entity = source_entity

    @property
    def affected_entities(self):
        """
        List of all the entities that are affected by the event or audit.

        :type:
             list[ :class:`~ntnx_monitoring_py_client.models.monitoring.v4.common.EntityReference` ]
        """  # noqa: E501
        return self.__affected_entities

    @affected_entities.setter
    def affected_entities(self, affected_entities):

        self.__affected_entities = affected_entities

    @property
    def metric_details(self):
        """
        Details of the metric for a metric-based event.

        :type:
             list[ :class:`~ntnx_monitoring_py_client.models.monitoring.v4.common.MetricDetail` ]
        """  # noqa: E501
        return self.__metric_details

    @metric_details.setter
    def metric_details(self, metric_details):

        self.__metric_details = metric_details

    @property
    def event_type(self):
        """
        A preconfigured or dynamically generated unique value for each event type.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__event_type

    @event_type.setter
    def event_type(self, event_type):

        self.__event_type = event_type

    @property
    def classifications(self):
        """
        Various categories into which this event type can be classified. For example, hardware, storage, or license.

        :type:
            list[ :class:`~str` ]
        """  # noqa: E501
        return self.__classifications

    @classifications.setter
    def classifications(self, classifications):

        self.__classifications = classifications

    @property
    def source_cluster_uuid(self):
        """
        Cluster UUID associated with the source entity of the event.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__source_cluster_uuid

    @source_cluster_uuid.setter
    def source_cluster_uuid(self, source_cluster_uuid):
        if source_cluster_uuid is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', source_cluster_uuid):  # noqa: E501
            raise ValueError(r"Invalid value for `source_cluster_uuid`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__source_cluster_uuid = source_cluster_uuid

    @property
    def creation_time(self):
        """
        The time in ISO 8601 format when the event was created.

        :type:
                :class:`~datetime`
        """  # noqa: E501
        return self.__creation_time

    @creation_time.setter
    def creation_time(self, creation_time):

        self.__creation_time = creation_time

    @property
    def message(self):
        """
        Additional message associated with the event.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__message

    @message.setter
    def message(self, message):
        if message is not None and len(message) > 1024:
            raise ValueError("Invalid value for `message`, length must be less than or equal to `1024`")  # noqa: E501

        self.__message = message

    @property
    def cluster_uuid(self):
        """
        Cluster UUID associated with the cluster where the event was first raised.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__cluster_uuid

    @cluster_uuid.setter
    def cluster_uuid(self, cluster_uuid):
        if cluster_uuid is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', cluster_uuid):  # noqa: E501
            raise ValueError(r"Invalid value for `cluster_uuid`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__cluster_uuid = cluster_uuid

    @property
    def parameters(self):
        """
        Additional parameters associated with the event. These parameters can be used to indicate custom key-value pairs for a given event instance. For example, a service down event in Prism Central can have the service name as a parameter.

        :type:
             list[ :class:`~ntnx_monitoring_py_client.models.monitoring.v4.common.Parameter` ]
        """  # noqa: E501
        return self.__parameters

    @parameters.setter
    def parameters(self, parameters):

        self.__parameters = parameters

    @property
    def service_name(self):
        """
        The service which raised the event or audit. For internal Nutanix services, this value is set to \"Nutanix\".

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__service_name

    @service_name.setter
    def service_name(self, service_name):
        if service_name is not None and len(service_name) > 50:
            raise ValueError("Invalid value for `service_name`, length must be less than or equal to `50`")  # noqa: E501

        self.__service_name = service_name

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(Event, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Event):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

